;~@sa1 <-- DO NOT REMOVE THIS LINE!
macro define_sprite_table(name, addr, addr_sa1, addr_more_sprites)
    !<name> = <addr_more_sprites>
endmacro

!RadiusRAM = $404000		;This holds the radius value. You can change this to anything from #$00-#$FF whenenver you want to change the radius
							;The initial value will be what's set on !InitialRadius
!CenterXRAM = $404001
!CenterYRAM = $404002

!InputTable = $404010

!ExtraBits		= $400040 ;$6040; $6040	;22 bytes	extra bits of sprite
!NewCodeFlag		= $400056 ;$6056; $6056	;01 byte	flag indicating whether the sprite being process uses custom code
!ExtraProp1		= $400057 ;$6057; $6057	;22 bytes
!ExtraProp2		= $40006D ;$606D; $606D	;22 bytes
!NewSpriteNum		= $400083 ;$6083; $6083	;22 bytes	custom sprite number

!SampleSpace = $09			;\ Used as the probability of the sprite pressing the wrong key
!Event = $01				;/ Basically we generate a number from 0 to !SampleSpace. If it's < !Event, the sprite enters the wrong key
!MaxError = $02				; The max number of mistakes the sprite can make
!MaxRadius = $30			; Max balloon size

%define_sprite_table(sprite_num, $9E, $9E, $3200)
%define_sprite_table(sprite_speed_y, $AA, $AA, $9E)
%define_sprite_table(sprite_speed_x, $B6, $B6, $B6)
%define_sprite_table(Actions_Pointer, $C2, $C2, $D8)
%define_sprite_table(sprite_y_low, $D8, $D8, $3216)
%define_sprite_table(sprite_x_low, $E4, $E4, $322C)
%define_sprite_table(sprite_status, $14C8, $74C8, $3242)
%define_sprite_table(sprite_y_high, $14D4, $74D4, $3258)
%define_sprite_table(sprite_x_high, $14E0, $74E0, $326E)
%define_sprite_table(sprite_speed_y_frac, $14EC, $74EC, $74C8)
%define_sprite_table(sprite_speed_x_frac, $14F8, $74F8, $74DE)
%define_sprite_table(NextAction, $1504, $7504, $74F4)	
%define_sprite_table(TurnFlag, $1510, $7510, $750A)
%define_sprite_table(CurrentInput, $151C, $751C, $3284)
%define_sprite_table(BarAnimation, $1528, $7528, $329A)
%define_sprite_table(PressedFlag, $1534, $7534, $32B0)
%define_sprite_table(MiscTimer, $1540, $7540, $32C6)
%define_sprite_table(WrongTimer, $154C, $754C, $32DC)
%define_sprite_table(sprite_misc_1558, $1558, $7558, $32F2)
%define_sprite_table(sprite_misc_1564, $1564, $7564, $3308)
%define_sprite_table(BarNum, $1570, $7570, $331E)
%define_sprite_table(MistakeCount, $1594, $7594, $3360)
%define_sprite_table(sprite_blocked_status, $1588, $7588, $334A)
%define_sprite_table(sprite_obj_interact, $15DC, $75DC, $7562)
%define_sprite_table(sprite_tweaker_167a, $167A, $767A, $7616)
%define_sprite_table(sprite_off_screen_vert, $186C, $786C, $7642)
%define_sprite_table(sprite_off_screen_horz, $15A0, $75A0, $3376)
%define_sprite_table(sprite_index_in_level, $161A, $761A, $7578)
%define_sprite_table(AllocFlag, $1602, $7602, $33CE)
%define_sprite_table(GFX_Pointer, $160E, $760E, $33E4)			;Used for arms
%define_sprite_table(GFX_Pointer2, $1626, $7626, $758E)		;Used for face expression

print "INIT ",pc
PHB : PHK : PLB
LDA #$01
STA $19
LDA #$01
STA $78BD
STZ $73E0
LDA #$20
STA !MiscTimer,x
JSR ClearInput
;LDA #$04
;STA !CurrentInput,x
PLB
RTL

print "MAIN ",pc
PHB
PHK
PLB
LDA.b #%00110000	;Disable Start+Select
STA $6DAA 			;
STA $6DAC			;Disable L/R

LDA !sprite_x_low,x
STA !CenterXRAM
LDA !sprite_y_low,x
CLC : ADC #$3C
STA !CenterYRAM
JSR Main
PLB
RTL

Returnnn:
RTS
Main:
JSR Graphics
JSR TimeBar

LDA !sprite_status,x			;\
CMP #$08			; | If sprite dead,
BNE Returnnn			;/ Return.

LDA $9D 		;\ 
BNE Returnnn 	;/ If sprites are locked, return.

LDA #$01
STA $78BD
STZ $73E0

LDA !Actions_Pointer,x
BEQ +
CMP #$03
BEQ +
CMP #$05
BEQ +

LDA $13
AND #$3F
CMP #$20
BNE +
LDA !RadiusRAM
INC A
STA !RadiusRAM

+
LDA !Actions_Pointer,x
PHX ; preserve X, because there is a very likely chance that it is already being used
ASL A ; multiply the base value to get the desired index
TAX ; put the resulting value into X
REP #$20 ; set A to 16-bit
LDA StatePointer,x ; load value from pointer table
STA $0A ; and store that to scratch RAM
SEP #$20 ; set A back to 8-bit
PLX ; pull X register back
JMP ($000A) ; jump to address that was stored

StatePointer:
dw Initialize
dw GenInput
dw PlayerTurn
dw BalloonMovement
dw SpriteTurn
dw PlayerWins
dw EndLevel


Initialize:
LDA !MiscTimer,x
BNE +
LDA #$1E
STA $7DF9
LDA !RadiusRAM
INC A
STA !RadiusRAM
CMP #$08
BNE +
INC !Actions_Pointer,x
LDA #$02
STA !NextAction,x
;STA !TurnFlag,x		;If this is different than 1, it's sprite's turn and all graphics need to be "?"
+

RTS


GenInput:

PHX
LDX #$00
-
LDA #$FF
JSL RANDOM	;
JSL RANDOM	;freaking shit random rng routines
LDA #$07
JSL RANDOM	;\Generate a number from 1 to 8, 4 times

INC A
STA !InputTable,x
INX
CPX #$04
BNE -
PLX

LDA !NextAction,x
STA !Actions_Pointer,x

RTS

inputIndex:		;Format: Low byte tells if it's $16 or $18, High byte is the actual value
dw $FFFF
dw $0800
dw $0100
dw $0400
dw $0200
dw $8002
dw $8000
dw $FFFF		;Special case
dw $4002

playerLose:
LDA #$00
STA !RadiusRAM

LDA #$19
STA $7DFC

JSL $00F606
RTS
PlayerTurn:
LDA !RadiusRAM
CMP #!MaxRadius
BCS playerLose
LDA !CurrentInput,x
CMP #$04
BNE .stillTrying
INC !Actions_Pointer,x
STZ !BarAnimation,x
STZ !BarNum,x
STZ !CurrentInput,x
LDA #$00
STA !InputTable
STA !InputTable+1
STA !InputTable+2
STA !InputTable+3
LDA #$C0
STA !sprite_speed_y,x
LDA #$39
STA !sprite_speed_x,x
STZ !sprite_speed_y_frac,x
STZ !sprite_speed_x_frac,x
LDA #$04
STA !NextAction,x
LDA #$01
STA !TurnFlag,x
RTS
.stillTrying
LDA !WrongTimer,x
CMP #$02
BCS .uh
CMP #$01
BEQ .uhh

LDA $14
AND #$01
BNE ++
INC !BarAnimation,x
LDA !BarAnimation,x
CMP #$04
BNE +
STZ !BarAnimation,x
INC !BarNum,x
+
LDA !BarNum,x
CMP #$12
BNE ++
BRA wrongKey
++

LDA $16
BNE pressedSomething
LDA $18
BNE pressedSomething
STZ !PressedFlag,x
.uh
RTS
.uhh
STZ !CurrentInput,x
STZ !BarAnimation,x
STZ !BarNum,x
RTS

endTurn:
LDX $75E9
RTS

pressedSomething:
LDA !PressedFlag,x
BNE endTurn
LDA !CurrentInput,x
CMP #$04
BEQ endTurn
TAX
LDA !InputTable,x
ASL A
TAY
LDA inputIndex,y
CMP #$FF
BEQ YCase
TAX
LDA $16,x
AND inputIndex+1,y
BNE correctKey
wrongKey:
LDA #$2A
STA $7DFC
LDX $75E9
LDA #$18
STA !WrongTimer,x
LDA #$01
STA !PressedFlag,x
RTS
correctKey:
LDA #$29
STA $7DFC
LDX $75E9
INC !CurrentInput,x
LDA #$01
STA !PressedFlag,x
RTS

YCase:
LDA $16
AND #$40
BEQ wrongKey
LDA $18
AND #$40
BNE wrongKey
BRA correctKey

BalloonMovement:
LDA #$08
STA $7DFC
LDA !NextAction,x
CMP #$04
BEQ .case1

LDA !sprite_x_low,x
CMP #$30
BCC +
JSL $01802A
RTS
.case1
LDA !sprite_x_low,x
CMP #$C9
BCS +
JSL $01802A
RTS
+
LDA #$01
STA !Actions_Pointer,x
RTS

spriteLose:
STZ !BarAnimation,x
STZ !BarNum,x
STZ !CurrentInput,x
LDA #$00
STA !RadiusRAM
STA !InputTable
STA !InputTable+1
STA !InputTable+2
STA !InputTable+3
STZ !TurnFlag,x
INC !Actions_Pointer,x
LDA !sprite_y_low,x
CLC : ADC #$13
STA !sprite_y_low,x
LDA #$D0
STA !sprite_x_low,x
LDA #$19
STA $7DFC
LDA #$E0
STA !sprite_speed_y,x
LDA #$05
STA !sprite_speed_x,x
RTS

endSpriteTurn:
LDA #$03
STA !Actions_Pointer,x
STZ !BarAnimation,x
STZ !BarNum,x
STZ !CurrentInput,x
LDA #$00
STA !InputTable
STA !InputTable+1
STA !InputTable+2
STA !InputTable+3
LDA #$C0
STA !sprite_speed_y,x
LDA #$C7
STA !sprite_speed_x,x
STZ !sprite_speed_y_frac,x
STZ !sprite_speed_x_frac,x
LDA #$02
STA !NextAction,x
LDA #$00
STA !TurnFlag,x
STZ !MistakeCount,x
RTS

iHateThis:
BRL spriteLose

SpriteTurn:
LDA !RadiusRAM
CMP #!MaxRadius
BCS iHateThis
;So we basically generate 2 random numbers per input. One of them is for how long the sprite takes to press the correct input
;The other one is the chance that the sprite actually presses the wrong key
LDA !CurrentInput,x
CMP #$04
BEQ endSpriteTurn

LDA !WrongTimer,x
CMP #$02
BCS .stillThinking
CMP #$01
BEQ .resetStuff

LDA $14
AND #$01
BNE ++
INC !BarAnimation,x
LDA !BarAnimation,x
CMP #$04
BNE +
STZ !BarAnimation,x
INC !BarNum,x
+
LDA !BarNum,x
CMP #$12
BNE ++
BRA .wrongKey
++

LDA !MiscTimer,x
CMP #$02
BCS .stillThinking
CMP #$01
BEQ .tryToInput

-
LDA !MistakeCount,x
CMP #!MaxError
BCS +
LDA #$28
JSL RANDOM			;Input delay
CMP #$10
BCC -
BRA ++
+
LDA #$20
JSL RANDOM
CMP #$08
BCC -
++
STA !MiscTimer,x

.stillThinking
RTS

.resetStuff
STZ !CurrentInput,x
STZ !BarAnimation,x
STZ !BarNum,x
RTS

.tryToInput
LDA !MistakeCount,x
CMP #!MaxError
BCS .rightKey
LDA #!SampleSpace
JSL RANDOM
CMP #!Event
BCS .rightKey
.wrongKey
LDA #$2A
STA $7DFC
LDX $75E9
LDA #$18
STA !WrongTimer,x
INC !MistakeCount,x
RTS
.rightKey
LDA #$29
STA $7DFC
LDX $75E9
INC !CurrentInput,x
RTS

PlayerWins:
LDA !sprite_blocked_status,x
AND #$04
BNE +
JSL $01802A
RTS
+
LDA #$0E
STA !MiscTimer,x
INC !Actions_Pointer,x
LDA #$09	; Passed level music, change to 0B for passed boss music
STA $7DFB	; Plays music
RTS

EndLevel:
LDA !MiscTimer,x
BNE +
LDA #$0B
STA $71
LDA #$FF	; \ End
STA $7493	; / Level
+
RTS

CrossTilemap:
db $81
db $90,$91,$90
db $81

CrossXDisp:
db $08
db $00,$08,$10
db $08

CrossYDisp:
db $00
db $08,$08,$08
db $10

CrossProp:			;Doesn't include color (added manually)
db $01
db $01,$01,$41
db $81

ButtonTilemap:
db $A0,$A1,$B0,$B1	;ABXY

ButtonProp:
db $0B,$09,$07,$05

ArrowXDisp:
db $38,$60,$88,$B0

Arrow2XDisp:
db $48,$70,$98,$C0

spriteLoseGFX:
JSR GetDrawInfo

LDA $00
STA $6300,y

LDA $01
STA $6301,y

LDA #$8C
STA $6302,y

LDA #$08
ORA $64
STA $6303,y

LDA #$00
LDY #$02

JSL $01B7B3	;This actually just makes thing harder for me
				;Shouldn't be necessary since this sprite should be the only one on screen
RTS


Graphics:
LDA !Actions_Pointer,x
CMP #$05
BEQ spriteLoseGFX
CMP #$06
BEQ spriteLoseGFX
JSR GetDrawInfo

STZ $05		;Number of tiles drawn
STZ $06		;Current Input being read
LDA #$38
STA $07		;Current xOffset

;Koopa sprite
LDA #$D0
STA $6300,y
STA $6304,y
LDA #$B0
STA $6301,y
LDA #$A0
STA $6305,y

LDA #$A0
STA $6302,y
LDA #$82
STA $6306,y

LDA #$08
ORA $64
STA $6303,y
STA $6307,y

PHY
TYA
LSR A
LSR A
TAY
LDA #$02
STA $6460,y
STA $6461,y
PLY

INC $05
INY #8

LDA !InputTable
BNE +
BRL .hehe
+
;Small Arrow
PHX
LDX #$00
-
LDA Arrow2XDisp,x
CLC : ADC #$0C
STA $6300,y

LDA #$48
STA $6301,y

LDA #$80
STA $6302,y

LDA #$0D
ORA $64
STA $6303,y

PHY
TYA
LSR A
LSR A
TAY
LDA #$00
STA $6460,y
PLY

INY #4
INC $05
INX
CPX #$03
BNE -
PLX

;Big Arrow
LDA !CurrentInput,x
CMP #$04
BEQ .hehe

PHX
TAX
LDA ArrowXDisp,x
CLC : ADC #$04
STA $6300,y
PLX

LDA #$30
STA $6301,y

PHX
LDA !WrongTimer,x
BEQ .yeahArrow

LDA #$88
BRA ++

.yeahArrow
LDA $14
LSR #4
AND #$01
BNE +
LDA #$A6
BRA ++
+
LDA #$86
++
STA $6302,y
PLX

LDA #$0D
ORA $64
STA $6303,y

PHY
TYA
LSR A
LSR A
TAY
LDA #$02
STA $6460,y
PLY

INC $05
INY #4

.hehe


InputLoop:
LDX $06
CPX #$04
BEQ +

PHX
LDX $75E9
LDA !TurnFlag,x
BNE bypass			;Make everything question marks if sprite turn
PLX

LDA !InputTable,x
PHX ; preserve X, because there is a very likely chance that it is already being used
ASL A ; multiply the base value to get the desired index
TAX ; put the resulting value into X
REP #$20 ; set A to 16-bit
LDA InputPointer,x ; load value from pointer table
STA $0A ; and store that to scratch RAM
SEP #$20 ; set A back to 8-bit
PLX ; pull X register back
JMP ($000A) ; jump to address that was stored

+
JMP FinishGraphics

InputPointer:
dw Nothing		;When nothing should be drawn
dw InputUp
dw InputRight
dw InputDown
dw InputLeft
dw InputA
dw InputB
dw InputY
dw InputX

bypass:
PLX
LDA !InputTable,x
BEQ .hax
LDA $07
CLC : ADC #$04
STA $6300,y
STA $6304,y

LDA #$40
STA $6301,y
LDA #$50
STA $6305,y

LDA #$84
STA $6302,y
LDA #$A4
STA $6306,y

PHX
LDX $75E9
LDA !CurrentInput,x
DEC
PLX
CMP $06
BMI .sure
LDA #$0F
BRA ++

.sure
LDA #$0B
++
ORA $64
STA $6303,y
STA $6307,y

PHY
TYA
LSR A
LSR A
TAY
LDA #$02
STA $6460,y
LDA #$02
STA $6461,y
PLY

INY #8
INC $05
INC $05
.hax
LDA $07
CLC : ADC #$28	;18 from the cross size + 10 for spacing
STA $07

INC $06
JMP InputLoop

Nothing:
INC $06
JMP InputLoop

InputUp:
LDX #$00	;X = current tile being draw
.loop

LDA #$00
JSR CrossGFX

INX
INY #4
INC $05
CPX #$05
BNE .loop

LDA $07
CLC : ADC #$28	;18 from the cross size + 10 for spacing
STA $07

INC $06
JMP InputLoop

InputRight:
LDX #$00	;X = current tile being draw
.loop

LDA #$03
JSR CrossGFX

INX
INY #4
INC $05
CPX #$05
BNE .loop

LDA $07
CLC : ADC #$28	;18 from the cross size + 10 for spacing
STA $07

INC $06
JMP InputLoop

InputDown:
LDX #$00	;X = current tile being draw
.loop

LDA #$04
JSR CrossGFX

INX
INY #4
INC $05
CPX #$05
BNE .loop

LDA $07
CLC : ADC #$28	;18 from the cross size + 10 for spacing
STA $07

INC $06
JMP InputLoop

InputLeft:
LDX #$00	;X = current tile being draw
.loop

LDA #$01
JSR CrossGFX

INX
INY #4
INC $05
CPX #$05
BNE .loop

LDA $07
CLC : ADC #$28	;18 from the cross size + 10 for spacing
STA $07

INC $06
JMP InputLoop

InputA:
LDX #$00
JSR ButtonGFX
LDA $07
CLC : ADC #$28	;11 from the button size + 10 for spacing
STA $07

INC $06
JMP InputLoop

InputB:
LDX #$01
JSR ButtonGFX
LDA $07
CLC : ADC #$28	;11 from the button size + 10 for spacing
STA $07

INC $06
JMP InputLoop

InputY:
LDX #$02
JSR ButtonGFX
LDA $07
CLC : ADC #$28	;11 from the button size + 10 for spacing
STA $07

INC $06
JMP InputLoop

InputX:
LDX #$03
JSR ButtonGFX
LDA $07
CLC : ADC #$28	;11 from the button size + 10 for spacing
STA $07

INC $06
JMP InputLoop


FinishGraphics:

LDX $75E9
LDY #$FF 
LDA $05 

;JSL $01B7B3	;This actually just makes thing harder for me
				;Shouldn't be necessary since this sprite should be the only one on screen

RTS

CrossGFX:
STA $0F
LDA $07
CLC
ADC CrossXDisp,x
STA $6300,y

LDA #$40
CLC
ADC CrossYDisp,x
STA $6301,y

LDA CrossTilemap,x
STA $6302,y

PHX
LDX $75E9
LDA !CurrentInput,x
DEC
PLX
CMP $06
BMI .sure
;If button was pressed sucessfuly, change palette
LDA CrossProp,x
ORA #$0E
BRA ++

.sure
CPX $0F
BNE +
LDA CrossProp,x
ORA #$0A
BRA ++
+
LDA CrossProp,x
ORA #$0C
++
ORA $64
STA $6303,y

PHY
TYA
LSR A
LSR A
TAY
LDA #$00
STA $6460,y
PLY
RTS

ButtonGFX:
LDA $07
CLC : ADC #$04
STA $6300,y
CLC : ADC #$04
STA $6304,y
LDA #$44
STA $6301,y
CLC : ADC #$04
STA $6305,y
LDA #$82
STA $6302,y
LDA ButtonTilemap,x
STA $6306,y

PHX
LDX $75E9
LDA !CurrentInput,x
DEC
PLX
CMP $06
BMI .sure
LDA ButtonProp,x
ORA #$0E
BRA ++
.sure
LDA ButtonProp,x
++
ORA $64
STA $6303,y
STA $6307,y

PHY
TYA
LSR A
LSR A
TAY
LDA #$02
STA $6460,y
LDA #$00
STA $6461,y
PLY

INY #8
INC $05
INC $05
RTS

barTilemap:
db $A2,$B2,$A3,$B3

TimeBar:
LDA !Actions_Pointer,x
CMP #$02
BEQ drawBar
CMP #$04
BEQ drawBar
RTS

drawBar:
JSR GetDrawInfo		;Idk why I'm even doing this

LDA !BarNum,x
STA $05
BEQ .noInitialTiles

PHX
LDX #$00
.loop
TXA
ASL #3
CLC
ADC #$37
STA $6200,y

LDA #$60
STA $6201,y

LDA #$B3
STA $6202,y

LDA #$09
ORA $64
STA $6203,y

INY #4
INX
CPX $05
BNE .loop
PLX

.noInitialTiles

LDA $05
ASL #3
CLC
ADC #$37
STA $6200,y

LDA #$60
STA $6201,y

PHX
LDA !BarAnimation,x
TAX
LDA barTilemap,x
STA $6202,y
PLX

LDA #$09
ORA $64
STA $6203,y

RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; miscellaneous standard subroutines
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Table1:	db $0C,$1C
Table2:	db $01,$02
Table3:	db $40,$B0
Table6:	db $01,$FF
Table4:	db $30,$C0,$A0,$C0,$A0,$F0,$60,$90,$30,$C0,$A0,$80,$A0,$40,$60,$B0
Table5:	db $01,$FF,$01,$FF,$01,$FF,$01,$FF,$01,$FF,$01,$FF,$01,$00,$01,$FF
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SubOffScreen - Optimized version
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Argument
; Y : type (#$00=X0, #$02=X1 ... #$0E=X7)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
SubOffScreenSA1:
		LDA !sprite_off_screen_horz,x
		ORA !sprite_off_screen_vert,x
		BEQ .Return2
		LDA !sprite_tweaker_167a,x
		AND #$04
		BNE .Return2
		LDA $5B
		LSR A
		BCS .VerticalLevel
		LDA !sprite_y_low,x
		ADC #$50
		LDA !sprite_y_high,x
		ADC #$00
		CMP #$02
		BCS .EraseSprite
		LDA !sprite_x_high,x
		XBA
		LDA !sprite_x_low,x
		REP #$21
		ADC .AddTable,y
		SEC
		SBC $1A
		CMP .CmpTable,y
.Common		SEP #$20
		BCC .Return2
.EraseSprite	LDA !sprite_status,x
		CMP #$08
		BCC .KillSprite
		LDY !sprite_index_in_level,x
		CPY #$FF
		BEQ .KillSprite
		TYX
		LDA.l $418A00,x
		AND #$FE
		STA.l $418A00,x
		LDX.w $75E9
.KillSprite	STZ !sprite_status,x
.Return2	RTS

.VerticalLevel	LDA $13
		LSR A
		BCS .CheckY
		LDA !sprite_x_high,x
		XBA
		LDA !sprite_x_low,x
		REP #$21
		ADC.w #$0040
		CMP.w #$0280
		BRA .Common
.CheckY		LDA !sprite_y_high,x
		XBA
		LDA !sprite_y_low,x
		REP #$20
		SBC $1C
		CLC
		ADC.w #$0070
		CMP.w #$01D0
		BRA .Common

.AddTable	dw $0040,$0040,$0010,$0070
		dw $0090,$0050,$0080,$FFC0
.CmpTable	dw $0170,$01E0,$01B0,$01D0
		dw $0230,$01B0,$0220,$0160

GetDrawInfo:

STZ $7642,x
STZ $3376,x
LDA $322C,x
CMP $1A
LDA $326E,x
SBC $1B
BEQ OnscreenX
INC $3376,x
OnscreenX:
LDA $326E,x
XBA
LDA $322C,x
REP #$20
SEC
SBC $1A
CLC
ADC.w #$0040
CMP #$0180
SEP #$20
ROL A
AND #$01
STA $7536,x
BNE Invalid

LDY #$00
LDA $75EA,x
AND #$20
BEQ OnscreenLoop
INY
OnscreenLoop:
LDA $3216,x
CLC
ADC Table1,y
PHP
CMP $1C
ROL $00
PLP
LDA $3258,x
ADC #$00
LSR $00
SBC $1D
BEQ OnscreenY
LDA $7642,x
ORA Table2,y
STA $7642,x
OnscreenY:
DEY
BPL OnscreenLoop
LDY $33A2,x
LDA $322C,x
SEC
SBC $1A
STA $00
LDA $3216,x
SEC
SBC $1C
STA $01
RTS

Invalid:
PLA
PLA
RTS

ClearInput:
PHX
LDA #$00
LDX #$00
-
STA !InputTable,x
INX
CPX #$04
BNE -
PLX
RTS


;============;
;RNG by 1024
;============;

RANDOM:
	PHX
	PHP
	SEP #$30
	PHA
	JSL $01ACF9
	JSL $01ACF9
	PLX
	CPX #$FF
	BNE NORMALRT
	LDA $748B
	BRA ENDRANDOM
NORMALRT:
	INX
LDA #$00				; \ Set Multiplication Mode.
STA $2250				; /

	LDA $748B
	CLC : ADC $748D
	CLC : ADC $08
	CLC : ADC $68
	CLC : ADC $74B0
	CLC : ADC $74B1
	CLC : ADC $09
	CLC : ADC $0A
	CLC : ADC $0B
	CLC : ADC $0C
	CLC : ADC $0D
	CLC : ADC $0E
	CLC : ADC $0F
	CLC : ADC $13
	STA $748B
	STA $2251
	STZ $2252
	STX $2253
	STZ $2254
	NOP
	LDA $2307	
ENDRANDOM:
	PLP
	PLX
	RTL